package betterwithmods.common.world.gen.feature;

import betterwithmods.common.blocks.BlockStump;
import net.minecraft.block.BlockOldLog;
import net.minecraft.block.BlockPlanks;
import net.minecraft.block.state.IBlockState;
import net.minecraft.init.Blocks;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.World;
import net.minecraft.world.gen.feature.WorldGenTrees;

import java.util.Random;

/**
 * Hardcore Stumping tree.
 *
 * @author Koward
 */
public class WorldGenTreesWithStump extends WorldGenTrees {
    private final IBlockState metaWood;

    public WorldGenTreesWithStump(boolean p_i2027_1_) {
        super(p_i2027_1_);
        this.metaWood = Blocks.field_150364_r.func_176223_P().func_177226_a(BlockOldLog.field_176301_b, BlockPlanks.EnumType.OAK);
    }

    public WorldGenTreesWithStump(boolean p_i46446_1_, int p_i46446_2_, IBlockState p_i46446_3_, IBlockState p_i46446_4_, boolean p_i46446_5_) {
        super(p_i46446_1_, p_i46446_2_, p_i46446_3_, p_i46446_4_, p_i46446_5_);
        this.metaWood = p_i46446_3_;
    }

    @Override
    public boolean func_180709_b(World worldIn, Random rand, BlockPos position) {
        boolean vanillaResult = super.func_180709_b(worldIn, rand, position);
        if (vanillaResult && BlockStump.canPlaceStump(worldIn, position)) {
            IBlockState stump = BlockStump.getStump(metaWood);
            if (stump == null) return vanillaResult;
            this.func_175903_a(worldIn, position, stump);
        }
        return vanillaResult;
    }
}
